#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int> > edges;
vector<int> vis;
vector<int> pr;
vector<int> dp[2];
vector<int> dp3[2];
vector<int> dist;
vector<int> color;
vector<int> weight;
vector<int> in_cycle;

int cnt_cycle = 0;

vector<vector<int> > cycles;

bool cycle;

void dfs(int v, int d = 0, int col = 1) {
    dist[v] = d;
    dp[1][v] = 1;
    vis[v] = true;
    for (int i = 0; i < (int)edges[v].size(); i++) {
        int u = edges[v][i];
        if (!vis[u]) {
            pr[u] = v;
            dfs(u, d + 1, -col);
            dp[0][v] += max(dp[1][u], dp[0][u]);
            dp[1][v] += dp[0][u];
        } else if (!cycle && u != pr[v]){
            cycle = true;
            vector<int> a;
            int q = v;
            while (q != u || q == -1) {
                in_cycle.push_back(q);
                a.push_back(q);
                color[q] = cnt_cycle;
                q = pr[q];
            }
            if (q != -1) {
            in_cycle.push_back(q);
            a.push_back(q);
            color[q] = cnt_cycle;
            }
            cnt_cycle++;
            cycles.push_back(a);
        }
    }
}

void dfs2(int v) {
    dp3[0][v] = 1;
    vis[v] = true;
     for (int i = 0; i < (int)edges[v].size(); i++) {
        int u = edges[v][i];
        if (!vis[u] && (color[u] != color[v] || color[v] == -1)) {
            dfs2(u);
            dp3[1][v] += max(dp3[0][u], dp3[1][u]);
            dp3[0][v] += dp3[1][u];
        }
     }
}


int main() {
    int n;
    cin >> n;
    edges.resize(n);
    vis.resize(n);
    dp[0].resize(n);
    dp[1].resize(n);
    dp3[0].resize(n);
    dp3[1].resize(n);
    pr.resize(n, -1);
    dist.resize(n);
    weight.resize(n);
    color.resize(n, -1);
    int v;
    bool check = true;
    bool check2 = true;
    for (int i = 0; i < n; i++) {
        cin >> v;
        if (v == -1) {
            if (i != 0) {
                check = false;
            }
            continue;
        }
        v--;
        if (i == 0) {
            check = false;
        }
        if (v != i - 1) {
            check = false;
        }
        if (v >= i) {
            check2 = false;
        }
        edges[i].push_back(v);
        edges[v].push_back(i);
    }
    if (check) {
        cout << (n / 2) + (n % 2) << endl;
        return 0;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (!vis[i]) {
            cycle = false;
            dfs(i);
            if (!cycle) {
                ans += max(dp[0][i], dp[1][i]);
            }
        }
    }
    if (cnt_cycle == 0) {
        cout << ans << endl;
        return 0;
    }
    for (int i = 0; i < n; i++) {
        vis[i] = false;
    }
    for (int i = 0; i < (int)in_cycle.size(); i++) {
        int v = in_cycle[i];
        if (!vis[v]) {
            dfs2(v);
        }
    }
    vector <int> dp2[2];
    dp2[0].resize(n);
    dp2[1].resize(n);
    int s1, s2;
    for (int i = 0; i < cnt_cycle; i++) {
        s1 = 0, s2 = 0;
        n = (int)cycles[i].size();
        int v = cycles[i][0];
        int u, prev;
        s1 = dp3[0][cycles[i][0]];
        s1 += dp3[1][cycles[i][1]];
        s1 += dp3[1][cycles[i][n - 1]];
        for (int j = 2; j < n - 1; j++) {
            u = cycles[i][j];
            prev = cycles[i][j - 1];
            if (j == 2) {
                dp2[0][u] = dp3[0][u];
                continue;
            }
            dp2[0][u] = dp2[1][prev] + dp3[0][u];
            dp2[1][u] = max(dp2[0][prev], dp2[1][prev]) + dp3[1][u];
        }
        s1 += max(dp2[0][cycles[i][n - 2]], dp2[1][cycles[i][n - 2]]);
        for (int j = 1; j < n; j++) {
            u = cycles[i][j];
            prev = cycles[i][j - 1];
            if (j == 1) {
                dp2[0][u] = dp3[0][u];
                continue;
            }
            dp2[0][u] = dp2[1][prev] + dp3[0][u];  // 0 beru
            dp2[1][u] = max(dp2[0][prev], dp2[1][prev]) + dp3[1][u];
        }
        s2 += dp3[1][cycles[i][0]];
        s2 += max(dp2[0][cycles[i][n - 1]], dp2[1][cycles[i][n - 1]]);
        ans += max(s1, s2);
    }
    cout << ans << endl;
    return 0;
}
